`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 03/21/2020 02:35:20 PM
// Design Name: 
// Module Name: Lab3_1
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////
module frq_div(
audio_mclk,
audio_lrck,
audio_sck,
f_crystal, // global clock input
rst_n // active low reset
);
input f_crystal; // global clock input
input rst_n; // active low reset

output reg audio_mclk;
output reg audio_lrck;
output reg audio_sck;




reg[1:0]ctl_25;
reg[1:0]tmp_ctl_25;
reg tmp_clk_25;

reg[7:0]ctl_25_128;
reg[7:0]tmp_ctl_25_128;
reg tmp_clk_25_128;

reg[2:0]ctl_25_4;
reg[2:0]tmp_ctl_25_4;
reg tmp_clk_25_4;

always @*
if(ctl_25 == 2'd1)
    begin
        tmp_clk_25 = ~audio_mclk;
        tmp_ctl_25 = 2'd0;
    end
else
   begin
        tmp_clk_25 = audio_mclk; 
        tmp_ctl_25 = ctl_25+1'd1;
   end   


always @(posedge f_crystal or negedge rst_n)
    if (~rst_n) 
        begin
            ctl_25 <= 2'd0;
            audio_mclk <= 0;
        end
    else 
        begin
            ctl_25 <=  tmp_ctl_25;
            audio_mclk <= tmp_clk_25;
        end

always @*
if(ctl_25_128 == 8'd255)
    begin
        tmp_clk_25_128 = ~audio_lrck;
        tmp_ctl_25_128 = 8'd0;
    end
else
   begin
        tmp_clk_25_128 = audio_lrck; 
        tmp_ctl_25_128 = ctl_25_128+1'd1;
   end   


always @(posedge f_crystal or negedge rst_n)
    if (~rst_n) 
        begin
            ctl_25_128 <= 8'd0;
            audio_lrck <= 1'd0;
        end
    else 
        begin
            ctl_25_128 <=  tmp_ctl_25_128;
            audio_lrck <= tmp_clk_25_128;
        end 
    
always @*
    if(ctl_25_4 == 3'd7)
        begin
            tmp_clk_25_4 = ~audio_sck;
            tmp_ctl_25_4 = 3'd0;
        end
    else
       begin
            tmp_clk_25_4 = audio_sck; 
            tmp_ctl_25_4 = ctl_25_4+1'd1;
       end   
    
    
always @(posedge f_crystal or negedge rst_n)
    if (~rst_n) 
        begin
            ctl_25_4 <= 3'd0;
            audio_sck <= 1'd0;
        end
    else 
        begin
            ctl_25_4 <=  tmp_ctl_25_4;
            audio_sck <= tmp_clk_25_4;
        end 
        

endmodule


    
