`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 04/28/2020 09:37:53 PM
// Design Name: 
// Module Name: test_speaker
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module test_speaker;

    reg f_crystal; // clock from crystal
    reg rst_n; // active low reset
    wire audio_mclk; // master clock
    wire audio_lrck; // left-right clock
    wire audio_sck; // serial clock
    wire audio_sdin; // serial audio data input
    
    Lab8_1 U0(
    .f_crystal(f_crystal), // clock from crystal
    .rst_n(rst_n), // active low reset
    .audio_mclk(audio_mclk), // master clock
    .audio_lrck(audio_lrck), // left-right clock
    .audio_sck(audio_sck), // serial clock
    .audio_sdin(audio_sdin) // serial audio data input
    );
    
    always #1 f_crystal=~f_crystal;
    
    initial
        begin
        f_crystal=0; rst_n=0;
        #1 rst_n=1;
        end
endmodule
