`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 04/28/2020 09:24:49 PM
// Design Name: 
// Module Name: speaker_control
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module speaker_control(
   audio_mclk,
   audio_lrck,
   audio_sck,
   f_crystal, // global clock input
   rst_n, // active low reset
   audio_left,
   audio_right,
   audio_sdin
   );
   output audio_mclk;
   output audio_lrck;
   output audio_sck;
   output audio_sdin;
   input f_crystal; // global clock input
   input rst_n; // active low reset
   input [15:0]audio_left;
   input [15:0]audio_right;
   
    frq_div U0(
    .audio_mclk(audio_mclk),
    .audio_lrck(audio_lrck),
    .audio_sck(audio_sck),
    .f_crystal( f_crystal), // global clock input
    .rst_n(rst_n) // active low reset
    );
    Parallel_to_Serial U1(
   .audio_sck(audio_sck),
    .audio_left(audio_left),
    .audio_right(audio_right),
    .s_out(audio_sdin),
    .rst_n(rst_n)
    );
endmodule
